/*****************************************
*  VbNZTgLQ[
*   H\
*   Sensor:RC0,RC1,RC2,RA2
*   LED:RB4,RB5,RB6,RB7
*****************************************/
#include  <16f785.h>
// RtBM[Vݒ
#fuses INTRC_IO,NOWDT,NOPROTECT,PUT,BROWNOUT,MCLR,NOIESO,NOFCMEN
#device ADC=10
#include  <stdlib.h>
// n[hEFAݒ
#use delay(CLOCK = 8000000)
#use FAST_IO(A)
#use FAST_IO(B)
#use FAST_IO(C)
// vg^CsO
int CheckTouch(void);
int SenseTouch(void);
void LEDCont(int Num);
void Buzzer(int Time);
void Display(void);
void Discharge(void);
void MakePatn(int Rnd);
/*** 萔Aϐ̐錾` ****/
int	i, k,Flag, Index, Check, ErrFlag;
int	Patn[10]; 							// Lp^[

/*********** C֐ **************/
void main(void)
{
	set_tris_a(0x0F);						// o̓[hݒ
	set_tris_b(0);
	set_tris_c(0xF7);						// uU[̂ݏo
	output_B(0x70);						// LED all Off
	output_high(PIN_C3);					// BZ off
	setup_adc(ADC_CLOCK_DIV_16);			// A/D ݒ//	
	setup_adc_ports(sAN4 | sAN5 | sAN6);	// AN4,5,6

	/********* C[v *************/
	while(1)
	{
		Index = 0;							// Lp^[ŏ̎w
		for(Index=0; Index<5; Index++){			// ō5ނ̋Lp^[JԂ
			MakePatn(Index);
			Buzzer(2);						// JnuU[200msec
			Discharge();						// ZTdZbg
			delay_ms(300);					// 300msec҂
			Display();						// LEDLp^[_
			Buzzer(2);						// uU[200msec
			// ZT̃^b`̃`FbN//
			k = 0;
			ErrFlag = 0;						// G[tOZbg
			Flag = 1;						// Pp^[SItOZbg
			while(Flag){						// Pp^[SI܂ŌJԂ
				Check = CheckTouch();			// ^b`̃`FbN
				LEDCont(Check);				// \
				if(Check == Patn[k]){			// Pf[^vH
					k++;						// ̃f[^
					if(Patn[k] == 0xFF)		// Pp^[SIH
						Flag = 0;			// ItOZbg
				}
				else{						// ԈႢ̏ꍇ
					ErrFlag = 0xFF;			// G[tOZbg
					Flag = 0;
					i = 10;					// I
					break;					// I
				}
			}
			// G[LŌpI
			if(ErrFlag == 0){					// G[łȂH
				Buzzer(1);					// pZuU[
				delay_ms(100);
				output_b(0x70);				// LEDS
				Buzzer(1);
				delay_ms(2000);				// ̃p^[2b҂
			}
			else{							// G[̏ꍇuU[
				Buzzer(10);
				output_b(0);					// SLED_
				Buzzer(5);
				Flag = 0;					// I
				i = 10;
				break;
			}
		}
		// Sp^[Ȉꍇ
		if(ErrFlag == 0){						// Sp^[I
			output_b(0);						// SLED_
			for(i=0; i<10; i++){				// iuU[
				Buzzer(1);
				delay_ms(100);
			}
		}
		// Q[JԂp҂			
		delay_ms(1000);						// ̃Q[Jn҂
		output_b(0x70);						// all LED Off
		delay_ms(3000);
	}
}

/********************************
* p^[f[^̐
********************************/
void MakePatn(int Rnd){
	int Mix;

	Mix = rand();
	srand(Mix);
	for(i=0; i<Index+3; i++){
		Patn[i] = rand() & 0x07;
		if(Patn[i] == 7)
			Patn[i] = 6;					// 7̏ꍇ6ɕύX
	}
	Patn[i] = 0xFF;						// I}[N
}
/*******************************
* ^b`e𐔒lɕϊ
********************************/
int CheckTouch(void){
	int Result;

	Result = SenseTouch();					// ꂽZT`FbN
	switch(Result){						// lɕϊ
		case 1: Result = 0; break;
		case 2: Result = 1; break;
		case 4: Result = 2; break;
		case 3: Result = 3; break;
		case 5: Result = 4; break;
		case 6: Result = 5; break;
		case 7: Result = 6; break;
		default:Result = 0; break;
	}
	return(Result);						// ϊʂԂ
}		
/*****************************
*  ZT^b`̃`FbN
******************************/
int SenseTouch(void){
	unsigned long Data;
	int Touch;

	Touch = 0;						// lZbg
	/**** ^b`ZX ****/
	while(Touch == 0){
		for(i=0; i<30; i++){			// ZT20`FbN
			set_adc_channel(4);			// CH4f[^//
			delay_us(30);
			Data = read_adc();
			if(Data > 0x50)
				Touch |= 0x01;			// ꂽ1rbgڃI
			set_adc_channel(5);			// CH5f[^//
			delay_us(30);
			Data = read_adc();
			if(Data > 0x50)
				Touch |= 0x02;			// ꂽ2rbgڃI
			set_adc_channel(6);			// CH6f[^//
			delay_us(30);
			Data = read_adc();		
			if(Data > 0x50)
				Touch |= 0x04;			// ꂽ3rbgڃI
		}
	}
	Discharge();						// ZTdZbg
	return(Touch);					// ꂽlԂ
}
/****************************
* LED_Tu֐
*****************************/
void Display(void){
	int m;

	m = 0;
	while(Patn[m] != 0xFF){			// p^[̏I܂ŌJԂ
		LEDCont(Patn[m]);				// wLED̓_
		delay_ms(800);				// 0.8b_
		m++;							// ̃f[^
		output_b(0x70);				// LEDS
		delay_ms(500);				// 0.5b҂
	}
}
/****************************
*  LED
*****************************/
void LEDCont(int Num){
	switch(Num){							// wLED_
		case 0: output_b(0x60); break;
		case 1: output_b(0x50); break;
		case 2: output_b(0x30); break;
		case 3: output_b(0x40); break;
		case 4: output_b(0x20); break;
		case 5: output_b(0x10); break;
		case 6: output_b(0x00); break;
		default: break;
	}
}
/****************************
* ZTo̓Zbg
*****************************/
void Discharge(void){
	set_tris_c(0xF0);			// ZT̓so̓[hɂ
	output_c(0xF8);			// Lowo͂d
	delay_ms(5);				// 5msec҂
	set_tris_c(0xF7);			// ̓[hɖ߂
	delay_ms(5);				// 5msec҂
}
/*****************************
*  uU[Tu֐
*  100msecPʂŎw莞Ԗ
******************************/
void Buzzer(int Time){
	int t;

	output_low(PIN_C3);			// BZ On
	for(t=0; t<Time; t++)			// 100msecP
		delay_ms(100);
	output_high(PIN_C3);			// BZ off
}		